﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WM_INPUT_MouseTest
{
    public partial class Form1 : Form
    {
        InputDevice id;
        int deltaX;
        int deltaY;

        public Form1()
        {
            InitializeComponent();

            textBoxSensitivity.Text = (3.5f).ToString();
            textBoxYaw.Text = (0.022f).ToString();
            textBoxPitch.Text = (0.022f).ToString();

            id = new InputDevice(Handle);
            id.MouseMoved += new InputDevice.DeviceEventHandler(MouseMoved);

            ComputeAndUpdate();
        }

        private void ComputeAndUpdate()
        {
            float sensitivity;
            float yaw;
            float pitch;

            labelDeltaX.Text = deltaX.ToString();
            labelDeltaY.Text = deltaY.ToString();

            float.TryParse(textBoxSensitivity.Text, out sensitivity);
            float.TryParse(textBoxYaw.Text, out yaw );
            float.TryParse(textBoxPitch.Text, out pitch);

            float angleX = deltaX * sensitivity * yaw;
            float angleY = deltaY * sensitivity * pitch;

            labelAngleX.Text = angleX.ToString();
            labelAngelY.Text = angleY.ToString();
        }

        protected override void WndProc(ref Message message)
        {
            if (id != null)
            {
                id.ProcessMessage(message);
            }
            base.WndProc(ref message);
        }

        private void MouseMoved(object sender, InputDevice.MouseEventArgs e)
        {
            deltaX += e.DeltaX;
            deltaY += e.DeltaY;

            ComputeAndUpdate();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Space)
            {
                deltaX = 0;
                deltaY = 0;

                ComputeAndUpdate();

                e.SuppressKeyPress = true;
            }
        }

        private void textBox_TextChanged(object sender, EventArgs e)
        {
            ComputeAndUpdate();
        }
    }
}
